' Masse eines Parts bestimmen und in iProperties eintragen
' by KB Gathmann, 02.07.2007

Sub Mass_Props()
  ' Set a reference to the part document.
  ' This assumes a part document is active.
  Dim oPartDoc As PartDocument
  Set oPartDoc = ThisApplication.ActiveDocument

  ' Set a reference to the mass properties object.
  Dim oMassProps As MassProperties
  Set oMassProps = oPartDoc.ComponentDefinition.MassProperties

  ' Set the accuracy to medium.
  oMassProps.Accuracy = k_Medium

  ' Set own Property
  Dim oPropSet As PropertySet
  Set oPropSet = oPartDoc.PropertySets.Item("{D5CDD505-2E9C-101B-9397-08002B2CF9AE}")

  On Error Resume Next
  ' Try to obtain the PropertySet to see if it already exists
  Set oPropSet = oPropSet.Item("Masse")

  ' If PropertySet does not exist then add the new PropertySet
  If Err Then
    ' Add the new PropertySet
    Set oPropSet = oPropsets.Add("Masse")
    ' Adding the new Property to the new PropertySet
  Call oPropSet.Add("A Value", "Masse", 2)
  End If

  ' Set Mass-Value to own Property Masse
  Dim oProp As Property
  Set oProp = oPropSet.Item("Masse")
  oProp.Value = Round(oMassProps.Mass, 3) & " kg"
End Sub
